# eis-partner-portal
The EMIL PartnerPortal API description

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0
- Package version: 1.1.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen
For more information, please visit [https://www.emil.de](https://www.emil.de)

## Requirements.

Python >=3.6

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install eis.partner-portal
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import eis.partner-portal
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import eis.partner-portal
```

## Getting Started

The environment variables must be set in order to properly use this SDK.

```shell 
export EMIL_USERNAME=XXXXXXX
export EMIL_PASSWORD=XXXXXXX
```

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
import time
import eis.partner-portal
from pprint import pprint
from eis.partner-portal.api import intermediary_api
from eis.partner-portal.model.account_class import AccountClass
from eis.partner-portal.model.lead_class import LeadClass
from eis.partner-portal.model.list_accounts_response_class import ListAccountsResponseClass
from eis.partner-portal.model.list_leads_response_class import ListLeadsResponseClass
from eis.partner-portal.model.list_partners_response_class import ListPartnersResponseClass
from eis.partner-portal.model.list_policies_response_class import ListPoliciesResponseClass
from eis.partner-portal.model.partner_class import PartnerClass
from eis.partner-portal.model.policy_class import PolicyClass
# Defining the host is optional and defaults to https://apiv2.emil.de
# See configuration.py for a list of all supported configuration parameters.
configuration = eis.partner-portal.Configuration(
    host = "https://apiv2.emil.de"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Bearer is automatically handled with exported environment variables. However, you
# can manuallay configure Bearer authorization (JWT): bearer
configuration = eis.partner-portal.Configuration(
    access_token = 'YOUR_BEARER_TOKEN'
)

# After manual token becomes invalid, the SDK will default to re-login automatically
# with environment variable credentials.


# Enter a context with an instance of the API client
with eis.partner-portal.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = intermediary_api.IntermediaryApi(api_client)
    code = "code_example" # str | Unique identifier for the object.
    authorization = "Authorization_example" # str | Bearer Token: provided by the login endpoint under the name accessToken. (optional)

    try:
        # Retrieve the lead
        api_response = api_instance.get_lead(code, authorization=authorization)
        pprint(api_response)
    except eis.partner-portal.ApiException as e:
        print("Exception when calling IntermediaryApi->get_lead: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://apiv2.emil.de*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*IntermediaryApi* | [**get_lead**](docs/IntermediaryApi.md#get_lead) | **GET** /partner-portal/v1/intermediary/leads/{code} | Retrieve the lead
*IntermediaryApi* | [**get_partner**](docs/IntermediaryApi.md#get_partner) | **GET** /partner-portal/v1/intermediary/partners/{code} | Retrieve the partner
*IntermediaryApi* | [**get_policy**](docs/IntermediaryApi.md#get_policy) | **GET** /partner-portal/v1/intermediary/policies/{code} | Retrieve the policy
*IntermediaryApi* | [**get_policyholder**](docs/IntermediaryApi.md#get_policyholder) | **GET** /partner-portal/v1/intermediary/policyholders/{code} | Retrieve the policyholder
*IntermediaryApi* | [**list_leads**](docs/IntermediaryApi.md#list_leads) | **GET** /partner-portal/v1/intermediary/leads | List leads
*IntermediaryApi* | [**list_partners**](docs/IntermediaryApi.md#list_partners) | **GET** /partner-portal/v1/intermediary/partners | List partners
*IntermediaryApi* | [**list_policies**](docs/IntermediaryApi.md#list_policies) | **GET** /partner-portal/v1/intermediary/policies | List policies
*IntermediaryApi* | [**list_policyholders**](docs/IntermediaryApi.md#list_policyholders) | **GET** /partner-portal/v1/intermediary/policyholders | List policyholders


## Documentation For Models

 - [AccountClass](docs/AccountClass.md)
 - [AccountPolicyClass](docs/AccountPolicyClass.md)
 - [CreatePaymentMethodRequestDto](docs/CreatePaymentMethodRequestDto.md)
 - [CreatePolicyRequestDto](docs/CreatePolicyRequestDto.md)
 - [InsuredObjectTypeClass](docs/InsuredObjectTypeClass.md)
 - [InvoiceClass](docs/InvoiceClass.md)
 - [InvoiceItemClass](docs/InvoiceItemClass.md)
 - [InvoiceStatusClass](docs/InvoiceStatusClass.md)
 - [LeadBankAccountClass](docs/LeadBankAccountClass.md)
 - [LeadClass](docs/LeadClass.md)
 - [ListAccountsResponseClass](docs/ListAccountsResponseClass.md)
 - [ListLeadsResponseClass](docs/ListLeadsResponseClass.md)
 - [ListPartnersResponseClass](docs/ListPartnersResponseClass.md)
 - [ListPoliciesResponseClass](docs/ListPoliciesResponseClass.md)
 - [OmitTypeClass](docs/OmitTypeClass.md)
 - [PartnerClass](docs/PartnerClass.md)
 - [PartnerLinkClass](docs/PartnerLinkClass.md)
 - [PartnerRoleClass](docs/PartnerRoleClass.md)
 - [PolicyClass](docs/PolicyClass.md)
 - [PolicyObjectClass](docs/PolicyObjectClass.md)
 - [PolicyPremiumClass](docs/PolicyPremiumClass.md)
 - [PolicyPremiumItemClass](docs/PolicyPremiumItemClass.md)
 - [PolicyVersionClass](docs/PolicyVersionClass.md)
 - [PremiumFormulaClass](docs/PremiumFormulaClass.md)
 - [PremiumOverrideDto](docs/PremiumOverrideDto.md)
 - [PremiumOverrideRequestDto](docs/PremiumOverrideRequestDto.md)
 - [ProductClass](docs/ProductClass.md)
 - [ProductVersionClass](docs/ProductVersionClass.md)
 - [SepaDto](docs/SepaDto.md)
 - [TagClass](docs/TagClass.md)
 - [TimesliceClass](docs/TimesliceClass.md)
 - [UploadedDocumentDto](docs/UploadedDocumentDto.md)


## Documentation For Authorization


## bearer

- **Type**: Bearer authentication (JWT)


## Author

kontakt@emil.de


## Notes for Large OpenAPI documents
If the OpenAPI document is large, imports in eis.partner-portal.apis and eis.partner-portal.models may fail with a
RecursionError indicating the maximum recursion limit has been exceeded. In that case, there are a couple of solutions:

Solution 1:
Use specific imports for apis and models like:
- `from eis.partner-portal.api.default_api import DefaultApi`
- `from eis.partner-portal.model.pet import Pet`

Solution 2:
Before importing the package, adjust the maximum recursion limit as shown below:
```
import sys
sys.setrecursionlimit(1500)
import eis.partner-portal
from eis.partner-portal.apis import *
from eis.partner-portal.models import *
```

